﻿import mx.utils.Delegate;

// ************************
// Imagebar v1.0 05/22/07
// ************************

// Problem with limits when creating a bar from existing clips. 

// **************************************************************************** 
// Scroll to icon
// Add method to set change an icon on the bar, add a new icon to the bar
// Continuous scrolling mode, images cycle around
// Add scroll vertical option, maybe this could allow both horizontal and vertical
// Add blur option

// ****************************************************************************


class com.webdevils.ImageBar {
	
	private var my_width:Number;
	private var my_height:Number;
	private var icon_width:Number;
	private var icon_height:Number;
	private var icon_space:Number;
	
	private var border_weight:Number;
	private var border_color:Number;
	
	private var mask_depth:Number = 5;
	private var icons_depth:Number = 3;
	private var border_depth:Number = 11;
	
	private var container_mc:MovieClip;
	private var mask_mc:MovieClip;
	private var icons_mc:MovieClip;
	private var border_mc:MovieClip;
	
	private var icon_array:Array = new Array();
	private var icon_instance_array:Array = new Array();
	
	private var scroll_inside:Boolean = true;
	private var scroll_mode:Number = 1;
	
	private var l_limit:Number;
	private var r_limit:Number;
	private var scroll_range:Number;
	
	private var target_x:Number = 0;
	private var scroll_speed:Number = 0.33;
	private var scroll_on:Boolean = true;
	
	// relative scroll 
	private var rel_left:Number;
	private var rel_range:Number;
	
	// continuous scroll
	private var c_width:Number;
	private var cr_limit:Number;
	private var cl_limit:Number;
	
	
	// Constructor
	public function ImageBar( _mc:MovieClip, 
							 d:Number, 
							 w:Number, 
							 h:Number, 
							 i_array:Array,
							 iw:Number,
							 ih:Number, 
							 is:Number ) {
		if ( d != undefined ) {
			my_width = w;
			my_height = h;
			icon_width = iw;
			icon_height = ih;
			icon_space = is;
			icon_array = i_array.slice();
			build_image_bar( _mc, d );
		} else {
			container_mc = _mc;
			mask_mc = _mc.mask_mc;
			icons_mc = _mc.icons_mc;
			
			for ( var p in icons_mc ) {
				icon_instance_array.push( icons_mc[p] );
			}
			
			// icon_instance_array.reverse();
			
			my_width = mask_mc._width;
			my_height = mask_mc._height;
			
			icon_width = icon_instance_array[0]._width;
			icon_height = icon_instance_array[0]._height;
			icon_space = icon_instance_array[1]._x - icon_instance_array[0]._x - icon_instance_array[0]._width;
			// trace( icon_space );
			init_image_bar();
		}
	}
	
	// Make the image bar create a movie clip a mask and add icons
	private function build_image_bar( _mc:MovieClip, d:Number ):Void {
		container_mc = _mc.createEmptyMovieClip( "image_bar_mc", d );
		make_mask();
		make_icon_holder();
		init_image_bar();
	}
	
	// make a mask for the image bar
	private function make_mask():Void {
		mask_mc = container_mc.createEmptyMovieClip( "mask_mc", mask_depth );
		mask_mc.beginFill( 0x3333FF, 50 );
		mask_mc.moveTo( 0, 0 );
		mask_mc.lineTo( my_width, 0 );
		mask_mc.lineTo( my_width, my_height );
		mask_mc.lineTo( 0, my_height );
		mask_mc.lineTo( 0, 0 );
		mask_mc.endFill();
	}
	
	// Set the border width and color
	public function set_border( stroke_weight:Number, stroke_color:Number ):Void {
		border_weight = stroke_weight;
		border_color = stroke_color;
		make_border();
	}
	
	// Draw the border around the image bar
	private function make_border():Void {
		border_mc = container_mc.createEmptyMovieClip( "border_mc", border_depth );
		border_mc.lineStyle( border_weight, border_color );
		border_mc.moveTo( 0, 0 );
		border_mc.lineTo( my_width, 0 );
		border_mc.lineTo( my_width, my_height );
		border_mc.lineTo( 0, my_height );
		border_mc.lineTo( 0, 0 );
	}
	
	// Make a movie clip to hold all of the icons
	private function make_icon_holder():Void {
		icons_mc = container_mc.createEmptyMovieClip( "icons_mc", icons_depth );
		var icon_count = icon_array.length;
		for ( var i = 0; i < icon_count; i ++ ) {
			make_icon( icon_array[ i ] );
		}
		
		// var count = 0;
		for ( var p in icons_mc ) {
			icon_count --;
			icons_mc[p]._x = icon_count * ( icon_width + icon_space );
		}
		icons_mc._y = ( my_height - icon_height ) / 2;
	}
	
	// Add an icon to the image bar
	private function make_icon( the_symbol ):Void {
		var d = icons_mc.getNextHighestDepth();
		var the_mc = icons_mc.attachMovie( the_symbol, "icon_" + d, d );
		icon_instance_array.push( the_mc );
	}
	
	
	// *******************************************************************
	// Initialize the image bar
	private function init_image_bar():Void {
		icons_mc.setMask( mask_mc );
		
		// Use getBounds() figure limits
		/*
		var icon_bounds = icons_mc.getBounds( container_mc );
		
		for ( var p in icon_bounds ) {
			trace( p + ":" + icon_bounds[p] );
		}
		
		l_limit = icon_bounds.xMin + ( icon_space / 2 );
		r_limit = mask_mc._width - icon_bounds.xMax - ( icon_space / 2 );
		scroll_range = r_limit - l_limit;
		*/
		
		l_limit = icons_mc._x + ( icon_space / 1 );
		r_limit = mask_mc._width - icons_mc._width - ( icon_space / 1 );
		scroll_range = r_limit - l_limit;
		
		
		rel_left = icon_width / 2;
		rel_range = my_width - icon_width;
		
		container_mc.onEnterFrame = Delegate.create( this, scroll_icons );
	}
	
	
	// ----------------------------------------------------------------------
	// scroll the icons in the image bar
	private function scroll_icons():Void {
		if ( scroll_on ) {
			if ( scroll_inside ) {
				if ( !mask_mc.hitTest( _xmouse, _ymouse, false ) ) {
					return;
				}
			}
			
			if ( scroll_mode == 1 ) {
				/* A sliding script based on distance from center */
				var m = ( container_mc._xmouse - ( my_width / 2 ) ) * .1;
				target_x -= m;
				if ( target_x > l_limit ) {
					target_x = l_limit;
				} else if ( target_x < r_limit ) {
					target_x = r_limit;
				}
			
			} else if ( scroll_mode == 2 ) {
				/* slides mouse relative */
				target_x = -( ( container_mc._xmouse - rel_left ) / rel_range ) * ( icons_mc._width - mask_mc._width );
				if ( target_x > l_limit ) {
					target_x = l_limit;
				} else if ( target_x < r_limit ) {
					target_x = r_limit;
				}
			} else if ( scroll_mode == 3 ) {
				/* continuous scrolling */
				var m = ( container_mc._xmouse - ( my_width / 2 ) ) * .1;
				target_x = ( target_x - m ) % icons_mc._width;
				
			}
		}
		
		icons_mc._x -= ( icons_mc._x - target_x ) * scroll_speed;
	}
	// ----------------------------------------------------------------------
	
	// Set scroll inside box 
	public function scroll_inside_box( onOff:Boolean ):Void {
		scroll_inside = onOff;
	}
	
	// Set the auto scroll option
	public function auto_scroll( auto:Boolean ):Void {
		scroll_on = auto;
	}
	
	// scroll the bar x icon widths
	public function shift_icons( n:Number ):Void {
		target_x += ( icon_width + icon_space ) * n;
		if ( target_x < r_limit ) {
			target_x = r_limit;
		} else if ( target_x > l_limit ) {
			target_x = l_limit;
		}
	}
	
	// Shift icons the wisth of the mask
	public function shift_left( ):Void {
		target_x -= mask_mc._width;
		if ( target_x < r_limit ) {
			target_x = r_limit;
		} else if ( target_x > l_limit ) {
			target_x = l_limit;
		}
	}
	
	
	// Shift icons the wisth of the mask
	public function shift_right( ):Void {
		target_x += mask_mc._width;
		if ( target_x < r_limit ) {
			target_x = r_limit;
		} else if ( target_x > l_limit ) {
			target_x = l_limit;
		}
	}
	
	
	// Scroll bar %
	public function scroll_percent( n:Number ):Void {
		target_x = scroll_range * n;
	}
	
	// get array symbols
	public function get_icon_symbol_array():Array {
		return icon_array;
	}
	
	// get icon instances
	public function get_icon_instance_array():Array {
		return icon_instance_array;
	}
	
	// Set the speed the image bar shifts
	public function set_speed( n:Number ):Void {
		scroll_speed = n;
	}
	
}






